#********************************************************************************
echo Starting install of qemu-init ...                   # start the installation

QINSTMAN                 # placeholder for man page installation default function

# folders defined in conf-build
PREFIX="QPREFIX"
BINDIR="QBINDIR"
LIBDIR="QLIBDIR"
MANDIR="QPREFIX/man"
ETCDIR="QETCDIR"
VARDIR="QVARDIR"
DATDIR="QDATDIR"
RUNDIR="QRUNDIR"

USR=QUSR
GRP=QGRP
#echo "Installing user(s) and group(s) ..."
#[ -f mkusrgrp ] && source ./mkusrgrp          # should NOT be sourced w/ Makefile

HOMEDIR="QHOMEDIR"
[ -d $HOMEDIR ] || mkdir -p -m 0750 $HOMEDIR
chmod 01750 "$HOMEDIR"
chown $USR.$GRP $HOMEDIR

[ -d "$BINDIR" ] || mkdir -pv "$BINDIR"
[ -d "$LIBDIR" ] || mkdir -pv "$LIBDIR"
# the data dir should (have to) be in qemud's home always
mkdir -pv -m 3775 "$DATDIR"; chown "$USR"."$GRP" "$DATDIR"
# don't touch existing (FHS) directories
[ -d "$ETCDIR" ] || mkdir -pv -m 3775 "$ETCDIR" && chown "$USR"."$GRP" "$ETCDIR"
[ -d "$VARDIR" ] || mkdir -pv -m 2775 "$VARDIR" && chown "$USR"."$GRP" "$VARDIR"
[ -d "$RUNDIR" ] || mkdir -pv -m 3775 "$RUNDIR" && chown "$USR"."$GRP" "$RUNDIR"

cp -pv qemud-init   "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-init
cp -pv qemud-acl    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-acl
cp -pv qemud-ast    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-ast
cp -pv qemud-cfg    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-cfg
cp -pv qemud-reg    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-reg
cp -pv qemud-sio    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-sio
cp -pv qemud-tap    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-tap
cp -pv qemud-vnc    "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/qemud-vnc
cp -pv vncconnect   "$LIBDIR"; chown 0."$GRP" "$LIBDIR"/vncconnect
cp -dv qemud-br*    "$LIBDIR"

cp -pv qemu-adm     "$BINDIR"; chown 0."$GRP" "$BINDIR"/qemu-adm
cp -pv qemud        "$BINDIR"; chown 0."$GRP" "$BINDIR"/qemud

# create symlinks into FHS locations ...
# the 'sbin' folder is required always
[ -d "$PREFIX/sbin" ] || mkdir -p "$PREFIX/sbin"
#
if [ "$LN2FHS" = "Y" ] ; then
  # make sure the link destination folders exists
  [ -d "$PREFIX/bin" ]  || mkdir -p "$PREFIX/bin"
  if [ "$BINDIR" != "$PREFIX/bin" ] ; then
    ln -sfv $BINDIR/qemu-adm $PREFIX/bin | awk '{print $3,$2,$1;}'
  fi
  if [ "$BINDIR" != "$PREFIX/sbin" ] ; then
    ln -sfv $BINDIR/qemud $PREFIX/sbin | awk '{print $3,$2,$1;}'
  fi
else  # ... or move at least 'qemud' to 'sbin' (from FHS 'bin' only)
  [ "$BINDIR" = "$PREFIX/bin" ] && mv "$PREFIX/bin/qemud" "$PREFIX/sbin"
fi

# config files:
cp -nv registered.tpl    "$ETCDIR/registered"
cp -nv vncstatus.tpl     "$ETCDIR/vncstatus"
cp -nv vncoffset.tpl     "$ETCDIR/vncoffset"
chmod 0664 "$ETCDIR/registered" "$ETCDIR/vncoffset" "$ETCDIR/vncstatus"
# (hard)link etc/vncstatus to var/vncstatus
ln -f $ETCDIR/vncstatus $VARDIR/vncstatus
# these files should be owned by root always
chown 0 "$ETCDIR/registered" "$ETCDIR/vncoffset" "$ETCDIR/vncstatus"
# templates:
cp -v template-qemud.rc  "$ETCDIR"
cp -v template-qemu.cfg  "$ETCDIR"

# optional install's
[ -d "/etc/sudoers.d" ] && cp -v sudo-qemud /etc/sudoers.d/qemud

# the $HOME/.ssh file
mkdir -p $HOMEDIR/.ssh
chmod 0700 $HOMEDIR/.ssh
cp -nv dot-ssh-qemud $HOMEDIR/.ssh/authorized_keys
chown $USR $HOMEDIR/.ssh/authorized_keys

# man pages
manInstall

# delete files which are removed from package (silently)
rm -f "$ETCDIR/portsinit"
rm -f "$LIBDIR/qemud-cmd"
rm -f "$LIBDIR/qemud-mon"
rm -f "$LIBDIR/qtcpclient"
rm -f "$LIBDIR/qtcpconn-io"
rm -f "$MANDIR/qemud-cmd.8"
rm -f "$MANDIR/qemud-mon.8"

echo -e "\033[1m ... finished!\033[0m"
